/*
https://stackoverflow.com/questions/20617067/returning-function-pointer-type/20617529

http://c-faq.com/decl/spiral.anderson.html
*/
#include <stdio.h>

int sq(int x){return x * x;}
int cb(int y){return y * y * y;}
int (*ch(int z))(int){return (z < 0) ? sq : cb;}

int main()
{
   int r1 = f(-3)(-3);
   int r2 = f( 3)( 3);
   int(*h)(int) = f(-1);
   int r3 = h(-1);

   printf("r1 = %d\n", r1);
   printf("r2 = %d\n", r2);
   printf("r3 = %d\n", r3);
}

/*
(prog
  (fun sq (lambda x (* x x)))
  (fun cb (lambda y (* y y y)))
  (fun ch (lambda z (if (< z 0) sq cb)))
  (var r1 (apply (apply ch -3) -3))
  (var r2 (apply (apply ch  3)  3))
  (var h  (apply ch -1))
  (var r3 (apply h -1))
)
*/
